searchNodes=[{"doc":"A tiny and fast library to compile and render inline SVGs for Phoenix templates and live views.SVG files are images that are formatted as very simple, and usually small, text files. It is faster, and recommended, that you directly include the svg data in-line with your web pages instead of asking the browser to make additional calls to servers before it can render your pages. This makes your pages load faster.adept_svg renders your svg files as quickly as possible. To do this, it reads the svg files at compile-time and provides runtime access through a term stored in your beamfile.If you use nimble_publisher, this should be a familiar concept.To use adept_svg, you create a module in your project that wraps it, providing a compile-time place to build the library and runtime access to it. It also happens to make your template svg rendering code very simple.You do not need to store your svg files in the &quot;assets/static&quot; directory. Those files are copied into your application via a file based mechanism, whereas adept_svg compiles them in directly. I recommend simply using &quot;assets/svg&quot;.Each *.svg file must contain a single valid &lt;svg&gt;&lt;/svg&gt; tag set with data as appropriate. Anything before the &lt;svg&gt; tag or after the &lt;/svg&gt; is treated as comment and stripped from the text during compilation.Example wrapper moduledefmodule MyAppWeb.Svg do # Build the library at compile time @library Adept.Svg.compile( &quot;assets/svg&quot; ) # Accesses the library at run time defp library(), do: @library # Render an svg from the library def render( key, opts \\ [] ) do Adept.Svg.render( library(), key, opts ) end endTo use the library, you would alias MyAppWeb.Svg in a controller, live_view or your your main app module. This allows your template code to call Svg.render directly.Example use in a template&lt;%= Svg.render( &quot;heroicons/user&quot;, class: &quot;h-5 w-5 inline&quot; ) %&gt;Live reloadingIf you are using Phoenix, you can enable live reloading by simply telling Phoenix to watch the svgs directory. Open up &quot;config/dev.exs&quot;, search for live_reload: and add this to the list of patterns:live_reload: [ patterns: [ ..., ~r&quot;assets/svg/*/.*(svg)$&quot; ] ]","ref":"Adept.Svg.html","title":"Adept.Svg","type":"module"},{"doc":"Compile a folder of *.svg files into a library you can render from.The folder and it's subfolders will be traversed and all valid *.svg files will be added to the library. Each svg will be added to the library with a key that is relative path of the svg file, minus the .svg part. For example, if you compile the folder &quot;assets/svg&quot; and it finds a file with the path &quot;assets/svg/heroicons/calendar.svg&quot;, then the key for that svg is &quot;heroicons/calendar&quot; in the library.UsageThe best way to use Adept.Svg is to create a new module in your project that wraps it, providing storage for the generated library term. This also allows you to customize naming, rendering or compiling as required.Exampledefmodule MyAppWeb.Svg do # Build the library at compile time @library Adept.Svg.compile( &quot;assets/svg&quot; ) # Accesses the library at run time defp library(), do: @library # Render an svg from the library def render( key, opts \\ [] ) do Adept.Svg.render( library(), key, opts ) end endNote that @library is accessed through a function. The library could become large, so you want to wrap it with a function to ensure that it is only stored as a term in your beam file once.","ref":"Adept.Svg.html#compile/2","title":"Adept.Svg.compile/2","type":"function"},{"doc":"Renders an svg into a safe string that can be inserted directly into a Phoenix template.The named svg must be in the provided library, which should be build using the compile function.Optional: pass in a keyword list of attributes to insert into the svg tag. This can be used to add class=&quot;something&quot; tag attributes, phoenix directives such as phx-click, or even alpine directives such as @click=&quot;some action&quot;. Note that key names containing the underscore character &quot;_&quot; will be converted to the hyphen &quot;-&quot; character.You don't normally call Adept.Svg.render() directly, except in your wrapper module. Instead, you would alias MyAppWeb.Svg in a controller, live view or your your main app module. This allows your template code to call Svg.render directly, which is simple and looks nice.The following examples all use an aliased MyAppWeb.Svg, which wraps Adept.Svg.Example use in a template&lt;%= Svg.render( &quot;heroicons/menu&quot; ) %&gt; &lt;%= Svg.render( &quot;heroicons/user&quot;, class: &quot;h-5 w-5 inline&quot; ) %&gt;Other examplesWithout attributes:Svg.render( &quot;heroicons/menu&quot; ) {:safe, &quot;&lt;svg xmlns= ... &lt;/svg&gt;&quot;}With options:Svg.render( &quot;heroicons/menu&quot;, class: &quot;h-5 w-5&quot; ) {:safe, &quot;&lt;svg class=&quot;h-5 w-5&quot; xmlns= ... &lt;/svg&gt;&quot;} Svg.render( &quot;heroicons/menu&quot;, phx_click: &quot;action&quot; ) {:safe, &quot;&lt;svg phx-click=&quot;action&quot; xmlns= ... &lt;/svg&gt;&quot;} Svg.render( &quot;heroicons/menu&quot;, &quot;@click&quot;: &quot;alpine_action&quot; ) {:safe, &quot;&lt;svg @click=&quot;alpine_action&quot; xmlns= ... &lt;/svg&gt;&quot;}","ref":"Adept.Svg.html#render/3","title":"Adept.Svg.render/3","type":"function"},{"doc":"Adept.SvgA tiny and fast library to compile and render inline SVGs for Phoenix templates and live views.SVG files are images that are formatted as very simple, and usually small, text files. It is faster, and recommended, that you directly include the svg data in-line with your web pages instead of asking the browser to make additional calls to servers before it can render your pages. This makes your pages load faster.adept_svg renders your svg files as quickly as possible. To do this, it reads the svg files at compile-time and provides runtime access through a term stored in your beamfile.If you use nimble_publisher, this should be a familiar concept.To use adept_svg, you create a module in your project that wraps it, providing a compile-time place to build the library and runtime access to it. It also happens to make your template svg rendering code very simple.You do not need to store your svg files in the &quot;assets/static&quot; directory. Those files are copied into your application via a file based mechanism, whereas adept_svg compiles them in directly. I recommend simply using &quot;assets/svg&quot;.Each *.svg file must contain a single valid &lt;svg&gt;&lt;/svg&gt; tag set with data as appropriate. Anything before the &lt;svg&gt; tag or after the &lt;/svg&gt; is treated as comment and stripped from the text during compilation.","ref":"readme.html","title":"Adept.Svg","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding adept_components to your list of dependencies in mix.exs:def deps do [ {:adept_svg, &quot;~&gt; 0.3.1&quot;} ] endTo have Phoenix automatically recompile when you change your SVGs folder, add this line to the live_reload patterns section of your dev.exs configuration script.~r&quot;lib/my_app_web/assets/svg/.*(svg)$&quot;","ref":"readme.html#installation","title":"Adept.Svg - installation","type":"extras"},{"doc":"defmodule MyAppWeb.Svg do # Build the library at compile time @library Adept.Svg.compile( &quot;assets/svg&quot; ) # Accesses the library at run time defp library(), do: @library # Render an svg from the library def render( key, opts \\\\ [] ) do Adept.Svg.render( library(), key, opts ) end endTo use the library, you would alias MyAppWeb.Svg in a controller, live_view or your your main app module. This allows your template code to call Svg.render directly.An optional convenience step is to alias your SVG module in your myapp_web.ex file's view_helpers section. This is how it looks on my projects defp view_helpers do quote do ... alias MyAppWeb.Svg end end","ref":"readme.html#example-wrapper-module","title":"Adept.Svg - Example wrapper module","type":"extras"},{"doc":"&lt;%= Svg.render( &quot;heroicons/menu&quot; ) %&gt; &lt;%= Svg.render( &quot;heroicons/user&quot;, class: &quot;h-5 w-5 inline&quot; ) %&gt; &lt;%= Svg.render( &quot;heroicons/login&quot;, class: &quot;h-5 w-5&quot;, phx_click: &quot;action&quot; ) %&gt; &lt;%= Svg.render( &quot;heroicons/logout&quot;, &quot;@click&quot;: &quot;alpine_action&quot; ) %&gt;Live reloadingIf you are using Phoenix, you can enable live reloading by simply telling Phoenix to watch the svgs directory. Open up &quot;config/dev.exs&quot;, search for live_reload: and add this to the list of patterns:live_reload: [ patterns: [ ..., ~r&quot;assets/svg/*/.*(svg)$&quot; ] ]","ref":"readme.html#example-uses-in-a-template","title":"Adept.Svg - Example uses in a template","type":"extras"},{"doc":"Copyright 2021 Boyd Multerer Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Adept.Svg - License","type":"extras"}]